#![allow(unused_must_use)]

// TODO: logging (dropped errors)
pub mod client;
pub mod error;
pub mod jabber;
pub mod jid;
pub mod stanza;

pub use client::encrypted::JabberClient;
pub use error::JabberError;
pub use jabber::Jabber;
pub use jid::JID;

pub type Result<T> = std::result::Result<T, JabberError>;

#[cfg(test)]
mod tests {
    use std::str::FromStr;

    use crate::Jabber;
    use crate::JID;

    // #[tokio::test]
    // async fn get_sockets() {
    //     let jabber = Jabber::new(JID::from_str("cel@blos.sm").unwrap(), "password".to_owned());
    //     println!("{:?}", jabber.get_sockets().await)
    // }

    // #[tokio::test]
    // async fn connect() {
    //     Jabber::new(JID::from_str("cel@blos.sm").unwrap(), "password".to_owned())
    //         .unwrap()
    //         .connect()
    //         .await
    //         .unwrap()
    //         .ensure_tls()
    //         .await
    //         .unwrap()
    //         .start_stream()
    //         .await
    //         .unwrap();
    // }

    #[tokio::test]
    async fn login() {
        Jabber::new(JID::from_str("test@blos.sm").unwrap(), "slayed".to_owned())
            .unwrap()
            .login()
            .await
            .unwrap();
    }
}
