use serde::{Deserialize, Serialize};

#[derive(Deserialize, PartialEq, Debug)]
pub struct Mechanisms {
    #[serde(rename = "$value")]
    pub mechanisms: Vec<Mechanism>,
}

#[derive(Deserialize, PartialEq, Debug)]
pub struct Mechanism {
    #[serde(rename = "$text")]
    pub mechanism: String,
}

#[derive(Serialize, Debug)]
#[serde(rename = "auth")]
pub struct Auth {
    #[serde(rename = "@xmlns")]
    pub ns: String,
    #[serde(rename = "@mechanism")]
    pub mechanism: String,
    #[serde(rename = "$text")]
    pub sasl_data: Option<String>,
}

#[derive(Deserialize, Debug)]
pub struct Challenge {
    #[serde(rename = "@xmlns")]
    pub ns: String,
    #[serde(rename = "$text")]
    pub sasl_data: String,
}
